﻿XIncludeFile "Object.pbi"
XIncludeFile "Lock.pbi"

; Use native condition variables with on Linux
CompilerIf #PB_Compiler_OS = #PB_OS_Linux

	Class(Condition)
		wait.i()
		signal.i()
		signalAll.i()
		StaticMembers
			; See: /usr/include/x86_64-linux-gnu/bits/pthreadtypes.h
			#__SIZEOF_PTHREAD_COND_T = 48
		
			Structure pthread_cond_t__data
				__lock.l
				__futex.l
				__total_seq.q
				__wakeup_seq.q
				__woken_seq.q
				*__mutex
				__nwaiters.l
				__broadcast_seq.l
			EndStructure
			
			Structure pthread_cond_t
				StructureUnion
					__data.pthread_cond_t__data
					__size.a[#__SIZEOF_PTHREAD_COND_T]
					__align.q
				EndStructureUnion
			EndStructure
			
		Members
			cond.pthread_cond_t
			*lock.typem(Lock)
		Constructors
			Construct(create,(lock.type(Lock)))
		Definition
			ImportC ""
				pthread_cond_signal(*cond)
			EndImport
			
			Deconstructor
				this\lock\__self__\lock()
				pthread_cond_broadcast_(@this\cond)
				this\lock\__self__\unlock()
				pthread_cond_destroy_(@this\cond)
			EndDeconstructor
			
			Constructor(create,(lock.type(Lock)))
				this\lock = lock
				If pthread_cond_init_(@this\cond, 0)
					ConstructorFailure
				EndIf
			EndConstructor
			
			Method(wait,(this))
				pthread_cond_wait_(@this\cond, this\lock\mutex)
			EndMethod
			
			Method(signal,(this))
				pthread_cond_signal(@this\cond)
			EndMethod
			
			Method(signalAll,(this))
				pthread_cond_broadcast_(@this\cond)
			EndMethod
	EndClass

CompilerElse

	Class(Condition)
		wait.i()
		signal.i()
		signalAll.i()
		Members
			lock.type(Lock)
			s.i
			x.i
			h.i
			waiters.i
		Constructors
			Construct(create,(lock.type(Lock)))
		Definition
			Deconstructor
				FreeSemaphore(this\s)
				FreeSemaphore(this\h)
				FreeMutex(this\x)
			EndDeconstructor
			
			Constructor(create, (lock.type(Lock)))
				this\lock = lock
				this\s = CreateSemaphore()
		 		this\x = CreateMutex()
		 		this\h = CreateSemaphore()
		 		this\waiters = 0
			EndConstructor
			
			Method(wait,(this))
				LockMutex(this\x)
				this\waiters + 1
				UnlockMutex(this\x)
				this\lock\unlock()
				
				WaitSemaphore(this\s)
				SignalSemaphore(this\h)
				this\lock\lock()
			EndMethod
			
			Method(signal,(this))
				LockMutex(this\x)
				If (this\waiters)
					this\waiters - 1
					SignalSemaphore(this\s)
					WaitSemaphore(this\h)
				EndIf
				UnlockMutex(this\x)
			EndMethod
			
			Method(signalAll,(this))
				Protected i.i
				
				LockMutex(this\x)
				For i = 1 To this\waiters
					SignalSemaphore(this\s)
				Next
				While this\waiters
					this\waiters - 1
					WaitSemaphore(this\h)
				Wend
				UnlockMutex(this\x)
			EndMethod
	EndClass

CompilerEndIf

CompilerIf #PB_Compiler_IsMainFile
	Define lock.Lock = new(Lock)
	Define cv1.Condition = Condition::create(lock)
	Define cv2.Condition = Condition::create(lock)
	
	cv1\signal()
	;cv\wait()
	
	cv1\free()
	cv2\free()
	lock\free()
CompilerEndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 133
; FirstLine = 109
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; EnablePurifier