﻿; Abgeleitete Klassen sind:
; - IOStreamType
; - Serial

DeclareModule IOStream
	Interface IIOStream
		free()
		lock()
		tryLock()
		unlock()
		isOpen.i()
		availableData.i()
		writeData.i(*buffer, length.i)
		readData.i(*buffer, length.i)
	EndInterface
	
EndDeclareModule
Module IOStream : EndModule


;================ INTERNAL STUFF ================

DeclareModule IOStream_Internal
	Structure IOStream
		*vTable
		hMutex.i
	EndStructure
	
	Macro _lock()
		LockMutex(*this\hMutex)
	EndMacro
	Macro _unlock()
		UnlockMutex(*this\hMutex)
	EndMacro
	
	Declare newIOStream(*this.IOStream)
	
	Declare lock(*this.IOStream)
	Declare unlock(*this.IOStream)
	Declare tryLock(*this.IOStream)
	
EndDeclareModule
Module IOStream_Internal
	Procedure newIOStream(*this.IOStream)
		If Not *this
			ProcedureReturn #False
		EndIf
		
		*this\hMutex = CreateMutex()
		If Not *this\hMutex
			ProcedureReturn #False
		EndIf
		
		ProcedureReturn *this
	EndProcedure
	
	Procedure lock(*this.IOStream)
		LockMutex(*this\hMutex)
	EndProcedure
	
	Procedure unlock(*this.IOStream)
		UnlockMutex(*this\hMutex)
	EndProcedure
	
	Procedure.i tryLock(*this.IOStream)
		ProcedureReturn TryLockMutex(*this\hMutex)
	EndProcedure
EndModule
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 13
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; EnablePurifier