﻿XIncludeFile "Object.pbi"

CompilerIf #PB_Compiler_OS = #PB_OS_Linux

	Class(Monitor)
		wait.i()
		signal.i()
		signalAll.i()
		StaticMembers
			; See: /usr/include/x86_64-linux-gnu/bits/pthreadtypes.h
			#__SIZEOF_PTHREAD_COND_T = 48
		
			Structure pthread_cond_t__data
				__lock.l
				__futex.l
				__total_seq.q
				__wakeup_seq.q
				__woken_seq.q
				*__mutex
				__nwaiters.l
				__broadcast_seq.l
			EndStructure
			
			Structure pthread_cond_t
				StructureUnion
					__data.pthread_cond_t__data
					__size.a[#__SIZEOF_PTHREAD_COND_T]
					__align.q
				EndStructureUnion
			EndStructure
			
		Members
			cond.pthread_cond_t
		Definition
			ImportC ""
				pthread_cond_signal(*cond)
			EndImport
			
			DefaultConstructor
				If pthread_cond_init_(@this\cond, 0)
					ConstructorFailure
				EndIf
			EndDefaultConstructor
			
			Deconstructor
				LockMutex(superm(Object)\__objectLock)
				pthread_cond_broadcast_(@this\cond)
				UnlockMutex(superm(Object)\__objectLock)
				pthread_cond_destroy_(@this\cond)
			EndDeconstructor
			
			Method(wait,(this))
				pthread_cond_wait_(@this\cond, superm(Object)\__objectLock)
			EndMethod
			
			Method(signal,(this))
				pthread_cond_signal(@this\cond)
			EndMethod
			
			Method(signalAll,(this))
				pthread_cond_broadcast_(@this\cond)
			EndMethod
	EndClass

CompilerElse

	Class(Monitor)
		wait()
		signal()
		signalAll()
		Members
			s.i
			x.i
			h.i
			waiters.i
		Definition
			DefaultConstructor
				this\s = CreateSemaphore()
		 		this\x = CreateMutex()
		 		this\h = CreateSemaphore()
		 		this\waiters = 0
			EndDefaultConstructor
			
			Deconstructor
				FreeSemaphore(this\s)
				FreeSemaphore(this\h)
				FreeMutex(this\x)
			EndDeconstructor
			
			Method(wait,(this))
				LockMutex(this\x)
				this\waiters + 1
				UnlockMutex(this\x)
				UnlockMutex(superm(Object)\__objectLock)
				
				WaitSemaphore(this\s)
				SignalSemaphore(this\h)
				LockMutex(superm(Object)\__objectLock)
			EndMethod
			
			Method(signal,(this))
				LockMutex(this\x)
				If (this\waiters)
					this\waiters - 1
					SignalSemaphore(this\s)
					WaitSemaphore(this\h)
				EndIf
				UnlockMutex(this\x)
			EndMethod
			
			Method(signalAll,(this))
				Protected i.i
				
				LockMutex(this\x)
				For i = 1 To this\waiters
					SignalSemaphore(this\s)
				Next
				While this\waiters
					this\waiters - 1
					WaitSemaphore(this\h)
				Wend
				UnlockMutex(this\x)
			EndMethod
	EndClass
	
CompilerEndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 47
; FirstLine = 32
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; EnablePurifier