﻿;DebugLevel 10

DeclareModule ClassUtil
	EnableExplicit
	
	; ======================================= Helfer-Makros =======================================
	
	Macro __MacroColon__
		:
	EndMacro
	
	Macro __JoinMacroParts__(P1, P2=, P3=, P4=, P5=, P6=, P7=, P8=)
		P1#P2#P3#P4#P5#P6#P7#P8
	EndMacro
	
	Macro __CreateMacro__(name,macroBody)
		__JoinMacroParts__(Macro name, __MacroColon__, macroBody, __MacroColon__, EndMacro)
	EndMacro
	
	Macro __DQ__
		"
	EndMacro
	
	Macro __MakeString__(__text__)
		__DQ__#__text__#__DQ__
	EndMacro
	
	;Bug: http://purebasic.fr/english/viewtopic.php?f=23&t=63868
	;Prototype __default_constructor_prototype__(*super = 0)
	
	; ==================================== Klassen-Hierarchie =====================================
	
	Macro Class(__ClassName__,BaseClassName=Object)
		DeclareModule __ClassName__
			EnableExplicit
			__CreateMacro__(__class__, __ClassName__) :
			__CreateMacro__(__base__, BaseClassName) :
			UseModule ClassUtil
			
			; Function pointer to the default constructor. 0 if there is not default constructor or it is private.
			Define __default_constructor__.i
			
			Declare.i __DefaultConstructor__(*super = 0, callUserConstructor.i = #True)
			Declare.i __isInstance__(*__this__)
			
			Interface I#__ClassName__ Extends BaseClassName#::I#BaseClassName
	EndMacro
	
	Macro StaticMembers
		CompilerIf Not Defined(__MEMBERS__, #PB_Constant)
			EndInterface
		CompilerElse
			EndStructure
			#__MEMBERS_END_STRUCTURE__ = 1
		CompilerEndIf
		#__STATIC_MEMBERS__ = 1
	EndMacro
	
	Macro Members
			CompilerIf Not Defined(__STATIC_MEMBERS__, #PB_Constant)
				EndInterface
			CompilerEndIf
			#__MEMBERS__ = 1
			Structure __class__ Align #PB_Structure_AlignC
				*vTable
				*__pBase__.__base__#__base__
				*super.__class__#_Inherited
				__self__.I#__class__
	EndMacro
	
	Macro Constructors
		CompilerIf Not Defined(__MEMBERS__, #PB_Constant)
			Members
		CompilerEndIf
		CompilerIf Not Defined(__MEMBERS_END_STRUCTURE__, #PB_Constant)
			EndStructure
		CompilerEndIf
			#__CONSTRUCTORS__ = 1
	EndMacro
	
	Macro Definition
		CompilerIf Not Defined(__CONSTRUCTORS__, #PB_Constant)
			Constructors
		CompilerEndIf
			Structure __class__#_Inherited Extends __base__#::__base__#_Inherited Align #PB_Structure_AlignC
				__class__.__class__
			EndStructure
			Global Dim __vTable__.i(SizeOf(I#__class__) - 1)
		EndDeclareModule
		Interface __class__ Extends __class__#::I#__class__
		EndInterface
		Module __class__
			#__DEFINITION__ = 1
			Declare.i __UserDefaultConstructor__(*__this__.__class__)
			
			Procedure.i __isInstance__(this)
				If Not this
					ProcedureReturn #False
				EndIf
				If this\vTable = @__vTable__()
					ProcedureReturn #True
				EndIf
				ProcedureReturn __isInstance__(this\__pBase__)
			EndProcedure
			
			Procedure.i __DefaultConstructor__(*super.__class__#_Inherited = 0, callUserConstructor.i = #True)
				Debug __MakeString__(__class__) + "::DefaultConstructor Begin", 10
				If Not *super
					CompilerIf __MakeString__(__class__) = "Object"
						ProcedureReturn #False
					CompilerElse
						*super = AllocateStructure(__class__#_Inherited)
						If Not *super
							ProcedureReturn #False
						EndIf
						Debug __MakeString__(__class__) + "::DefaultConstructor AllocateStructure", 10
						If Not __base__#::__DefaultConstructor__(*super)
							Goto __error_free__
						EndIf
					CompilerEndIf
				Else
					CompilerIf __MakeString__(__class__) <> "Object"
						If Not __base__#::__DefaultConstructor__(*super)
							ProcedureReturn #False
						EndIf
					CompilerEndIf
				EndIf
		
				Protected *__this__.__class__ = @*super\__class__
				
				*__this__\vTable = @__vTable__()
				*__this__\super = *super
				*__this__\__self__ = @*super\__class__
				CompilerIf __MakeString__(__class__) <> "Object"
					*__this__\__pBase__ = @*super\__base__
				CompilerElse
					*__this__\__pBase__ = 0
				CompilerEndIf
					
				
				If callUserConstructor
					If Not __UserDefaultConstructor__(*__this__)
						CompilerIf OffsetOf(__class__#_Inherited\__class__) = 0
							FreeStructure(*__this__\super)
							Debug __MakeString__(__class__) + "::DefaultConstructor FreeStructure", 10
						CompilerElse
							super()\free()
						CompilerEndIf
						ProcedureReturn #False
					EndIf
				EndIf
				
				Debug __MakeString__(__class__) + "::DefaultConstructor End", 10
				ProcedureReturn *__this__
				
				__error_free__:
				FreeStructure(*super)
				Debug __MakeString__(__class__) + "::DefaultConstructor FreeStructure", 10
				ProcedureReturn #False
			EndProcedure
	EndMacro
	
	Macro EndClass
		CompilerIf Not Defined(__DEFINITION__, #PB_Constant)
			Definition
		CompilerEndIf
			; Wurde kein Destructor erstellt, erstelle selbst einen
			CompilerIf Not Defined(__DECONSTRUCTOR__, #PB_Constant)
				Deconstructor
				EndDeconstructor
			CompilerEndIf
			; Wurde kein Default Constructor erstellt, erstelle selbst einen, aber mache ihn nicht für new zugänglich.
			CompilerIf Not Defined(__DEFAULT_CONSTRUCTOR__, #PB_Constant)
				DefaultConstructor
				EndDefaultConstructor
				__default_constructor__ = 0
			CompilerEndIf
			CompilerIf Not Defined(toString, #PB_Procedure)
				Procedure.s toString(*__this__.__class__)
					ProcedureReturn "<" + __MakeString__(__class__) + " @" + Hex(*__this__, #PB_Quad) + ">"
				EndProcedure
			CompilerEndIf
			__vTable__(0) = @free()
			__vTable__(1) = @toString()

			CompilerIf __MakeString__(__base__) <> "ClassUtil"
				Define __i__.i
				For __i__ = 0 To SizeOf(__base__#::I#__base__) / SizeOf(Integer) - 1
					If __vTable__(__i__) = 0
						__vTable__(__i__) =  __base__#::__vTable__(__i__)
					EndIf
				Next
			CompilerEndIf
			UndefineMacro __class__
			UndefineMacro __base__
		EndModule
	EndMacro
	
	; ============================== Basis-Interface und -Strukturen ==============================
	
	Interface IClassUtil
	EndInterface
	
	Structure ClassUtil
	EndStructure
	Structure ClassUtil_Inherited
	EndStructure

	; ================================= Standard (De)Constructor ==================================
	
	Macro DefaultConstructor
		CompilerIf Defined(__DEFAULT_CONSTRUCTOR__, #PB_Constant)
			CompilerError "Default constructor already declared."
		CompilerEndIf
		#__DEFAULT_CONSTRUCTOR__ = 1
		Procedure.i __UserDefaultConstructor__(*__this__.__class__)
			Debug __MakeString__(__class__) + "::UserDefaultConstructor Begin", 10
	EndMacro
	
	Macro PrivateDefaultConstructor
		#__PRIVATE_DEFAULT_CONSTRUCTOR__ = 1
		DefaultConstructor
	EndMacro
	
	Macro EndDefaultConstructor
			Debug __MakeString__(__class__) + "::UserDefaultConstructor End", 10
			ProcedureReturn *__this__
		EndProcedure
		CompilerIf Not Defined(__DEFAULT_CONSTRUCTOR__, #PB_Constant)
			CompilerError "EndDefaultConstructor without DefaultConstructor."
		CompilerEndIf
		CompilerIf Defined(__PRIVATE_DEFAULT_CONSTRUCTOR__, #PB_Constant)
			__default_constructor__ = 0
		CompilerElse
			__default_constructor__ = @__DefaultConstructor__()
		CompilerEndIf
	EndMacro
	
	Macro Deconstructor
		CompilerIf Defined(__DECONSTRUCTOR__, #PB_Constant)
			CompilerError "Deconstructor already declared."
		CompilerEndIf
		#__DECONSTRUCTOR__ = 1
		Procedure.i free(*__this__.__class__)
			Debug __MakeString__(__class__) + "::Deconstructor Begin", 10
	EndMacro
	
	Macro EndDeconstructor
			CompilerIf OffsetOf(__class__#_Inherited\__class__) = 0
				FreeStructure(*__this__\super)
				Debug __MakeString__(__class__) + "::DefaultConstructor FreeStructure", 10
			CompilerElse
				super()\free()
			CompilerEndIf
			Debug __MakeString__(__class__) + "::Deconstructor End", 10
		EndProcedure
		CompilerIf Not Defined(__DECONSTRUCTOR__, #PB_Constant)
			CompilerError "EndDeconstructor without Deconstructor."
		CompilerEndIf
	EndMacro
	
	Macro ConstructorFailure
		Debug __MakeString__(__class__) + "::ConstructorFailure", 10
		CompilerIf #PB_Compiler_Procedure <> "__UserDefaultConstructor__"
			super()\free()
		CompilerEndIf
		ProcedureReturn 0
	EndMacro
	
	Macro CallConstructor(__ConstructorName__=,__ParameterList__=())
		CompilerIf __MakeString__(__ConstructorName__) = ""
			If Not __UserDefaultConstructor__(*__this__) : ConstructorFailure :	EndIf
		CompilerElse
			__ConstructorName__#_this = *__this__
			If Not __ConstructorName__#__ParameterList__
				__ConstructorName__#_this = 0
				ProcedureReturn 0
			Else
				__ConstructorName__#_this = 0
			EndIf
		CompilerEndIf
	EndMacro
	
	Macro Construct(__ConstructorName__,__ParamaterList__)
		CompilerIf Not Defined(__CONSTRUCTORS__, #PB_Constant)
			CompilerError "Construct without ClassConstructors"
		CompilerEndIf
		Threaded __ConstructorName__#_this.i
		Declare.i __ConstructorName__#__ParamaterList__
	EndMacro
	
	Macro Constructor(__ConstructorName__,__ParamaterList__=())
		CompilerIf Not Defined(__CONSTRUCTORS__, #PB_Constant)
			CompilerError "Constructor without ClassConstructors"
		CompilerEndIf
		#__CONSTRUCTOR_#MacroExpandedCount#__ = 1
		Procedure.i __ConstructorName__#__ParamaterList__
			Debug __MakeString__(__class__) + "::Constructor " + #PB_Compiler_Procedure + " Begin", 10
			Protected *__this__.__class__
			If __ConstructorName__#_this
				*__this__ = __ConstructorName__#_this
			Else
				*__this__ = __DefaultConstructor__(0, #False)
			EndIf
	EndMacro
	
	Macro EndConstructor
		CompilerIf Not Defined(__CONSTRUCTOR_#MacroExpandedCount#__, #PB_Constant)
			CompilerError "EndConstructor without Constructor"
		CompilerEndIf
			Debug __MakeString__(__class__) + "::Constructor " + #PB_Compiler_Procedure + " End", 10
			ProcedureReturn *__this__
		EndProcedure
	EndMacro
	
	; ====================================== Zugriffs-Helfer ======================================
	
	Macro type(__ClassName__) :
		__ClassName__#::I#__ClassName__
	EndMacro
	
	Macro typem(__ClassName__)
		__ClassName__#::__ClassName__
	EndMacro
	
	Macro new(__ClassName__)
		CallFunctionFast(__ClassName__#::__default_constructor__, 0, #True)
	EndMacro
	
	Macro super(BaseClass=__base__)
		*__this__\super\BaseClass\__self__
	EndMacro
	
	Macro superm(BaseClass=__base__)
		*__this__\super\BaseClass
	EndMacro
	
	Macro self
		*__this__\__self__
	EndMacro
	
	Macro this
		*__this__.__class__
	EndMacro
	
	Macro child
		__child__
	EndMacro
	
	Macro callable(__ClassName__,__MethodName__)
		(__ClassName__#::__vTable__(OffsetOf(__ClassName__#::I#__ClassName__\__MethodName__()) / SizeOf(Integer)))
	EndMacro
	
	Macro isinstance(__Object__,__ClassName__)
		(__ClassName__#::__isInstance__(__Object__))
	EndMacro
	
	;???
	Macro restricted(__varName__, __object__, __ClassName__)
		*__varName__.__ClassName__#::__ClassName__ = __object__
	EndMacro
	
	; ========================================= Methoden ==========================================
	
	Macro Method(__P1__,__P2__,__P3__=)
		CompilerIf __MakeString__(__P3__) = ""
			Declare __P1__#__P2__
			__vTable__(OffsetOf(I#__class__\__P1__()) / SizeOf(Integer)) = @__P1__()
			Procedure __P1__#__P2__
				Protected __result__.i = 0
				Debug __MakeString__(__class__) + "::" + __MakeString__(__P1__#__P2__) + " Begin", 10
		CompilerElse
			Declare.__P1__ __P2__#__P3__
			__vTable__(OffsetOf(I#__class__\__P2__()) / SizeOf(Integer)) = @__P2__()
			Procedure.__P1__ __P2__#__P3__
				Protected __result__.__P1__ 
				Debug __MakeString__(__class__) + "::" + __MakeString__(__P2__#__P3__) + " Begin", 10
		CompilerEndIf
		CompilerIf Not Defined(*__this__, #PB_Variable)
			CompilerError "Parameter 'this' is missing in Method's parameter list."
		CompilerEndIf
		*__this__ = *__this__\super\__class__\__self__
		Protected __child__.I#__class__ = *__this__ + SizeOf(__class__)
	EndMacro
	
	Macro Synchronized(__P1__,__P2__,__P3__=)
		Method(__P1__,__P2__,__P3__)
		LockMutex(*__this__\super\Object\__objectLock)
	EndMacro
	
	Macro EndMethod
			Debug "EndMethod", 10
			__method_end__:
			ProcedureReturn __result__
		EndProcedure
	EndMacro
	
	Macro EndSynchronized
			__method_end__:
			UnlockMutex(*__this__\super\Object\__objectLock)
			Debug "EndSynchronized", 10
			ProcedureReturn __result__
		EndProcedure
	EndMacro
	
	Macro MethodReturn(__RETURN__)
		__result__ = __RETURN__
		Goto __method_end__
	EndMacro
	
	Macro SynchronizedReturn(__RETURN__)
		__result__ = __RETURN__
		Goto __method_end__
	EndMacro
EndDeclareModule
Module ClassUtil : EndModule

UseModule ClassUtil

Class(Object, ClassUtil)
	free.i()
	toString.s()
	Members
		__objectLock.i
	Definition
		PrivateDefaultConstructor
			this\__objectLock = CreateMutex()
		EndDefaultConstructor
		
		Deconstructor
			FreeMutex(this\__objectLock)
		EndDeconstructor
EndClass
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 136
; FirstLine = 110
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory
; EnablePurifier