﻿XIncludeFile "Monitor.pbi"

Class(Queue, Monitor)
	push(*element)
	pop.i()
	
	Members
		List elements.i()
	Definition
		DefaultConstructor
		EndDefaultConstructor
		
		Synchronized(push,(this, *element))
			LastElement(this\elements())
			
			If AddElement(this\elements())
				this\elements() = *element
				self\signal()
				SynchronizedReturn(#True)
			EndIf
			
			SynchronizedReturn(#False)
		EndSynchronized
		
		Synchronized(i, pop,(this))
			Protected *element
			
			While Not FirstElement(this\elements())
				self\wait()
			Wend
			
			*element = this\elements()
			DeleteElement(this\elements())
			
			SynchronizedReturn(*element)
		EndSynchronized
EndClass

CompilerIf #PB_Compiler_IsMainFile
	Define queue.Queue = new(Queue)
	
	#threads = 9
	#values = 100
	
	Procedure Pusher(queue.Queue)
		Protected i.i
		For i = 1 To #values
			queue\push(i)
		Next
		queue\push(0)
		Debug "Thread beendet"
	EndProcedure
	
	Dim threads.i(#threads - 1)
	Define.i i
	For i = 0 To #threads - 1
		threads(i) = CreateThread(@Pusher(), queue)
	Next
	
	Define element.i
	i = #threads
 	Repeat
 		element = queue\pop()
 		If Not element
 			i - 1
 		Else
 			Debug element
 		EndIf
 		If i = 0
 			Break
 		EndIf
 	ForEver
	
	For i = 0 To #threads - 1
		WaitThread(threads(i))
	Next
	
	queue\free()
CompilerEndIf
; IDE Options = PureBasic 5.40 LTS Beta 9 (Linux - x64)
; CursorPosition = 36
; FirstLine = 15
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; CompileSourceDirectory
; EnablePurifier